unit jablka;

interface

uses
  Windows, SysUtils, Forms, Dialogs, ImgList, Controls, Classes, ExtCtrls,
  Graphics, DXDraws, StdCtrls, DXClass;

type
  TForm1 = class(TForm)
    DXDraw1: TDXDraw;
    DXImageList1: TDXImageList;
    Label1: TLabel;
    DXTimer1: TDXTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DXTimer1Timer(Sender: TObject; LagCount: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  jabkox, jabkoy: integer;
  panaca: integer;
  score: integer;
  sirka, vyska: integer;
  jablko: boolean;
  Rychlost: integer;
  F: TextFile;
  prvni, druhy, treti: string;
  s1, s2, s3: integer;
  Pause: boolean;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var s: string;
begin
  if not FileExists('jablicka.hi') then
  begin
    prvni:='Calimero 60';
    druhy:='Calimero 50';
    treti:='Calimero 40';
  end
  else
  begin
    AssignFile(F, 'jablicka.hi');
    Reset(F);
    readln(F, prvni);
    readln(F, druhy);
    readln(F, treti);
    CloseFile(F);
  end;
  s1:= StrToInt(Copy(prvni, Pos(' ', prvni) + 1, Length(prvni)));
  s2:= StrToInt(Copy(druhy, Pos(' ', druhy) + 1, Length(druhy)));
  s3:= StrToInt(Copy(treti, Pos(' ', treti) + 1, Length(treti)));
  ShowMessage('Nejvy dosaen score:' + #13 + prvni + #13 +
    druhy + #13 + treti);
  prvni:= Copy(prvni, 1, Pos(' ', prvni) - 1);
  druhy:= Copy(druhy, 1, Pos(' ', druhy) - 1);
  treti:= Copy(treti, 1, Pos(' ', treti) - 1);

  Randomize;
  score:= 0;
  sirka:= Form1.Width - 20;
  vyska:= Form1.Height - 70;
  jablko:= false;
  panaca:= sirka div 2;
  s:= '2';
  repeat
    if not InputQuery('Jablka' ,'Zadejte rychlost padn jablek (1-5):', s) then
//      Form1.Close;
      Continue;
    Rychlost:= StrToInt(s);
    if (Rychlost > 5) or (Rychlost < 1) then
      ShowMessage('Mimo meze (1-5)');
  until (Rychlost <= 5) and (Rychlost >= 1);
  DXTimer1.Enabled:= true;
  Pause:= false;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = ord('P') then
  begin
    Pause:= not Pause;
    DXTimer1.Enabled:= not DXTimer1.Enabled;
    exit;
  end;
  if Pause then exit;
//  ImageList.Draw(Canvas, panaca, vyska, 1, false);
  if Key = VK_LEFT then
    if panaca > 5 then
      dec(panaca,15);
  if Key = VK_RIGHT then
    if panaca < sirka then
      inc(panaca,15);

//  ImageList.Draw(Canvas, panaca, vyska, 1, true);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  AssignFile(F, 'jablicka.hi');
  Rewrite(F, 'jablicka.hi');
  Writeln(F, prvni + ' ' + IntToStr(s1));
  Writeln(F, druhy + ' ' + IntToStr(s2));
  Writeln(F, treti + ' ' + IntToStr(s3));
  CloseFile(F);
end;

procedure TForm1.DXTimer1Timer(Sender: TObject; LagCount: Integer);
begin
  if not DXDraw1.CanDraw then
    Exit;
  DXDraw1.Surface.Fill(clBlack);
//  ImageList.Draw(Canvas, jabkox, jabkoy, 0, false);
  if jablko = false then
  begin
    jabkox:= Random(sirka);
    jabkoy:= 0;
    jablko:= true;
  end
  else
    jabkoy:= jabkoy + Rychlost + 4;

//  ImageList.Draw(Canvas, jabkox, jabkoy, 0, true);
// Canvas.TextOut(0, 0, 'Score: ' + IntToStr(score));
  Label1.Caption:= 'Score: ' + IntToStr(score);

  if jabkoy > vyska - 20 then
  begin
    if (jabkox > panaca - 10) and (jabkox < panaca + 12) then
      inc(score, Rychlost)
    else
    begin
      DXTimer1.Enabled:= false;
      if score > s3 then
        if score > s2 then
        begin
          if score > s1 then
          begin
            treti:= druhy;
            druhy:= prvni;
            s3:= s2;
            s2:= s1;
            s1:= score;
            InputQuery('Jablka','Nov rekord. Vlote jmno:', prvni);
          end
          else
          begin
            treti:= druhy;
            s3:= s2;
            s2:= score;
            InputQuery('Jablka','Nov rekord. Vlote jmno:', druhy);
          end
        end
        else
        begin
          s3:= score;
          InputQuery('Jablka','Nov rekord. Vlote jmno:', treti);
        end;
      if MessageDlg('Konec. Score: ' + IntToStr(score) + #13 +
        'Chcete skonit?', mtInformation, [mbYes, mbNo], 0) = mrYes then
        Close;
      DXTimer1.Enabled:= true;
      score:= 0;
//      ImageList.Draw(Canvas, panaca, vyska, 1, false);
      panaca:= sirka div 2;
//      ImageList.Draw(Canvas, panaca, vyska, 1, true);
    end;
    jablko:= false;
  end;
  DXImageList1.Items[0].Draw(DXDraw1.Surface, jabkox, jabkoy, 0);
  DXImageList1.Items[1].Draw(DXDraw1.Surface, panaca, vyska, 0);
  DXDraw1.Flip;
end;

end.
